VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   780
   ClientLeft      =   120
   ClientTop       =   450
   ClientWidth     =   2400
   LinkTopic       =   "Form1"
   ScaleHeight     =   780
   ScaleWidth      =   2400
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton Command1 
      Caption         =   "Command1"
      Height          =   615
      Left            =   120
      TabIndex        =   0
      Top             =   90
      Width           =   2175
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private pIFactory As Long

Private Sub Command1_Click()

    Dim sAnimGif As String
    Dim lItem As Long
    Dim lFrameCount As Long
    Dim psAnimGif As Long
    Dim pIDecoder As Long
    Dim pIBitmapDecodeFrame As Long
    Dim pIConvertedFrame As Long
    
    sAnimGif = App.Path & "\anim.gif"
    psAnimGif = StrPtr(sAnimGif)

    ' ist ein WICImagingFactory-Interface vorhanden
    If pIFactory <> 0 Then

        ' einen Decoder von der GIF-Datei erstellen -> pIDecoder
        If IWICImagingFactory_CreateDecoderFromFilename_Proxy(pIFactory, psAnimGif, 0&, GENERIC_READ, WICDecodeMetadataCacheOnLoad, pIDecoder) = S_OK Then

            ' Anzahl der Frames in dem GIF ermitteln
            If IWICBitmapDecoder_GetFrameCount_Proxy(pIDecoder, lFrameCount) = S_OK Then

                ' mindestens 1 Frame
                If lFrameCount > 0 Then

                    ' alle Frames durchlaufen
                    For lItem = 0 To lFrameCount - 1
                    
                        ' ein einzelnes Frame aus dem GIF holen -> pIBitmapDecodeFrame
                        If IWICBitmapDecoder_GetFrame_Proxy(pIDecoder, lItem, pIBitmapDecodeFrame) = S_OK Then
                            
                            ' pIBitmapDecodeFrame -> IWICMetadataQueryReader -> auslesen diverser Eigenschaften
                            ' von diesem Frame
                            
                            ' GIF-Frame (8bppIndexed) zu einen 24bppBGR Bitmap konvertieren
                            ' kann man machen, muss man aber nicht.
                            If WICConvertBitmapSource(String2Guid(GUID_WICPixelFormat24bppBGR), pIBitmapDecodeFrame, pIConvertedFrame) = S_OK Then
                                
                                Debug.Print "Schreibe Frame " & CStr(lItem + 1) & " von " & CStr(lFrameCount)
                                
                                ' konvertiertes Frame als Bitmap speichern
                                Call SaveFrameAsBitmap(pIConvertedFrame, lItem)
                            
                                ' konvertiertes Frame freigeben
                                Call ReleaseInterface(pIConvertedFrame)
                            
                            End If
                            
                            ' GIF-Frame freigeben
                            Call ReleaseInterface(pIBitmapDecodeFrame)
                        
                        End If

                    Next

                End If
                
            End If

            ' Decoder freigeben
            Call ReleaseInterface(pIDecoder)

        End If
        
        Debug.Print "Fertig!"
        
    End If

End Sub

Private Sub SaveFrameAsBitmap(ByVal pIBitmapFrame As Long, ByVal lFrameNumber As Long)

    Dim sBmpFrame As String
    Dim lWidth As Long
    Dim lHeight As Long
    Dim psBmpFrame As Long
    Dim pIStream As Long
    Dim pIEncoder As Long
    Dim pIWICStream As Long
    Dim pIEncoderOptions As Long
    Dim pIBitmapEncodeFrame As Long
    Dim tWICRect As WICRect

    sBmpFrame = App.Path & "\Frame_" & String$(3 - Len(CStr(lFrameNumber)), "0") & CStr(lFrameNumber) & ".bmp"
    psBmpFrame = StrPtr(sBmpFrame)
    
    ' einen WIC-Stream erstellen -> pIWICStream
    If IWICImagingFactory_CreateStream_Proxy(pIFactory, pIWICStream) = S_OK Then
    
        ' einen File-Stream erstellen -> pIStream
        If SHCreateStreamOnFileEx(psBmpFrame, STGM_CREATE Or STGM_WRITE, 0&, 0&, 0&, pIStream) = S_OK Then
        
            ' WIC-Stream mit dem File-Stream initialisieren
            If IWICStream_InitializeFromIStream_Proxy(pIWICStream, pIStream) = S_OK Then
            
                ' einen Bitmap-Encoder erstellen -> pIEncoder
                ' kann auch jeder andere untersttzte Encoder sein
                If IWICImagingFactory_CreateEncoder_Proxy(pIFactory, String2Guid(GUID_ContainerFormatBmp), 0&, pIEncoder) = S_OK Then
                
                    ' Encoder vom WIC-Stream initialisieren
                    If IWICBitmapEncoder_Initialize_Proxy(pIEncoder, pIWICStream, WICBitmapEncoderNoCache) = S_OK Then
                
                        ' dem Encoder ein neues Frame hinzufgen -> pIBitmapEncodeFrame
                        If IWICBitmapEncoder_CreateNewFrame_Proxy(pIEncoder, pIBitmapEncodeFrame, pIEncoderOptions) = S_OK Then
                        
                            ' ber pIEncoderOptions knnte man fr den Encoder entsprechende Optionen mitgeben
                            ' zb EnableV5Header32bppBGRA fr 32bpp Bitmaps
                            ' zb TiffCompressionMethod fr TIFF
                            
                            ' pIBitmapEncodeFrame -> IWICMetadataQueryWriter -> schreiben diverser Eigenschaften
                            ' von diesem Frame
                    
                            ' neues Frame initialisieren
                            If IWICBitmapFrameEncode_Initialize_Proxy(pIBitmapEncodeFrame, pIEncoderOptions) = S_OK Then
                
                                ' Gre des GIF-Frames ermitteln
                                If IWICBitmapSource_GetSize_Proxy(pIBitmapFrame, lWidth, lHeight) = S_OK Then

                                    ' entsprechend Gre fr das neue Frame setzen
                                    If IWICBitmapFrameEncode_SetSize_Proxy(pIBitmapEncodeFrame, lWidth, lHeight) = S_OK Then

                                        With tWICRect
                                            .x = 0
                                            .y = 0
                                            .width = lWidth
                                            .height = lHeight
                                        End With
                            
                                        ' GIF-Frame in das neue Frame schreiben
                                        If IWICBitmapFrameEncode_WriteSource_Proxy(pIBitmapEncodeFrame, pIBitmapFrame, tWICRect) = S_OK Then
                            
                                            ' nderungen am neuen Frame speichern
                                            Call IWICBitmapFrameEncode_Commit_Proxy(pIBitmapEncodeFrame)
                            
                                        End If
                            
                                    End If
                                
                                End If
                        
                            End If
                    
                            ' Encoderoptions freigeben
                            Call ReleaseInterface(pIEncoderOptions)
                    
                            ' neues Frame freigeben
                            Call ReleaseInterface(pIBitmapEncodeFrame)
                    
                        End If
                    
                    End If
    
                    ' nderungen am Encoder speichern
                    Call IWICBitmapEncoder_Commit_Proxy(pIEncoder)
                        
                    ' Encoder freigeben
                    Call ReleaseInterface(pIEncoder)
    
                End If
                
            End If
    
            ' File-Stream freigeben
            Call ReleaseInterface(pIStream)
            
        End If
        
        ' WIC-Stream freigeben
        Call ReleaseInterface(pIWICStream)
        
    End If

End Sub

Private Sub Form_Load()

    ' WICImagingFactory-Interface erstellen (Version 1)
    If WICCreateImagingFactory_Proxy(WINCODEC_SDK_VERSION1, pIFactory) <> S_OK Then

        Debug.Print "WICImagingFactory konnte nicht erstellt werden!"

    End If

End Sub

Private Sub Form_Unload(Cancel As Integer)

    ' ist ein WICImagingFactory-Interface vorhanden
    If pIFactory <> 0 Then

        ' WICImagingFactory-Interface freigeben
        Call ReleaseInterface(pIFactory)

    End If

End Sub
